Subject: bug#29473: 25.3; 'background-mode is 'light on console with black background

From: Noam Postavsky <[email-masked]>
Date: Sat, 02 Dec 2017 10:25:47 -0500

Tim Landscheidt <[email-masked]> writes:

> In newsticker tree view on a Linux console with black back-
> ground (both KDE's konsole application and "native" console
> (Alt-Ctrl-F2), all under Fedora),

> (frame-parameter nil 'background-mode) returns 'light.  This
> also happens with Emacs' current master branch.
>
> After glancing at the manual, I'm unclear whether:
>
> 1. Emacs should set 'background-mode correctly by itself
>    (and thus there is an error in the detection mechanism),
>
> 2. it is my duty to explicitly set background-mode (via
>    initial-frame-alist?) when using Emacs on a console, or

I'm pretty sure it's #1, the manual explains that background-mode nil
should use automatic detection, and it sounds like that detection is
going wrong.

I don't see anything in lisp/term/linux.el that sets the background mode
at all.  What does running 'echo $TERM' in a shell give you?

Looking at lisp/term/konsole.el, it looks like it uses the xterm
functions for everything.  Could you try stepping through/adding
'message' calls in terminal-init-xterm and see if/where it goes wrong?